JavaScript/jQuery Diagram - customShapes

Provide access to an array of custom shapes.

Type:

Array<Object>

Default Value: []

Use the customShapes property to extend a collection of built-in shapes with custom shapes.

Use the toolbox property to add the custom shapes to the toolbox.

index.js
  • $(function() {
  • var diagram = $("#diagram").dxDiagram({
  • customShapes: [{
  • category: "hardware",
  • type: "internet",
  • title: "Internet",
  • backgroundImageUrl: "images/shapes/internet.svg",
  • backgroundImageLeft: 0.15,
  • backgroundImageTop: 0,
  • backgroundImageWidth: 0.7,
  • backgroundImageHeight: 0.7,
  • defaultWidth: 0.75,
  • defaultHeight: 0.75,
  • defaultText: "Internet",
  • allowEditText: true,
  • textLeft: 0,
  • textTop: 0.7,
  • textWidth: 1,
  • textHeight: 0.3,
  • connectionPoints: [
  • { x: 0.5, y: 0 },
  • { x: 0.9, y: 0.5 },
  • { x: 0.5, y: 1 },
  • { x: 0.1, y: 0.5 }
  • ]
  • },
  • ...
  • ],
  • toolbox: {
  • groups: [{ category: "hardware", title: "Hardware" }]
  • }
  • }).dxDiagram("instance");

View Demo

See Also

allowEditImage

Specifies whether a card shape's image can be edited.

Type:

Boolean

Use the defaultImageUrl property to specify the default image that is displayed in the card. Set the allowEditImage property to true to allow users to change the image from a context menu.

Diagram - Card's context menu

See Also

defaultImageUrl

allowEditText

Specifies whether the shape's text can be edited.

Type:

Boolean

See Also

defaultText

allowResize

Specifies whether the shape can be resized.

Type:

Boolean

When shape resizing is enabled you can restrict shape sizes with the following properties: minWidth, maxWidth, minHeight, and maxHeight.

backgroundImageHeight

Specifies the shape background image's fractional height.

Type:

Number

This property specifies a fraction from 0 to 1 that represents the shape background image height in relation to the shape height. If the backgroundImageHeight property is set to 1, the image height is equal to the shape height.

The absolute image height is calculated by multiplying the backgroundImageHeight value by the shape's height.

backgroundImageLeft

Specifies the shape background image's left offset.

Type:

Number

This property specifies a fractional left offset of a shape background image toward the shape width. If the backgroundImageLeft property is set to 0, the image's left edge matches the shape's left edge.

The absolute offset is calculated by multiplying the backgroundImageLeft value by the shape's width.

backgroundImageToolboxUrl

Specifies the shape image displayed in the toolbox.

Type:

String

When a custom shape is created with a custom background image (the backgroundImageUrl property), you can use the backgroundImageToolboxUrl property to specify the image displayed for the shape in the toolbox.

If the property is not set, the toolbox displays an image specified in the backgroundImageUrl property.

NOTE
Shape background images should be supplied as SVG files.

Diagram - Custom shape's image properties

backgroundImageTop

Specifies the shape background image's top offset.

Type:

Number

This property specifies the top offset (in fractions) of a shape's background image in relation to the shape's height. If the backgroundImageTop property is set to 0, the image's top edge matches the shape's top edge.

The absolute offset is calculated by multiplying the backgroundImageTop value by the shape's height.

backgroundImageUrl

Specifies the shape background image's URL.

Type:

String

A custom shape can be created based on a default shape type (the baseType property) or with a custom background image (the backgroundImageUrl property).

Use the backgroundImageToolboxUrl property to specify an image displayed for the shape in the toolbox. If the property is not set, the toolbox displays an image specified in the backgroundImageUrl property.

Diagram - Custom shape's image properties

The backgroundImageUrl property is not in effect if the baseType is specified.

NOTE
Shape background images should be supplied as SVG files.

Rounded Rectangle Shape

  • <!-- roundedRect.svg -->
  • <svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewBox="0 0 48 26">
  • <g>
  • <rect rx="8" ry="8" x="0.5" y="0.5" width="47" height="25"
  • style="fill:#FFFFFF; stroke:#000000; stroke-width:2px;"/>
  • </g>

index.js
  • $(function() {
  • var diagram = $("#diagram").dxDiagram({
  • customShapes: [{
  • category: "custom",
  • type: "roundedRect",
  • title: "Rounded Rectangle",
  • backgroundImageUrl: "images/shapes/roundedRect.svg",
  • defaultWidth: 0.75,
  • defaultHeight: 0.5,
  • defaultText: "Text",
  • textTop: 0.35,
  • textHeight: 0.3,
  • }],
  • toolbox: {
  • groups: [{ category: "custom", title: "Custom" }]
  • }
  • }).dxDiagram("instance");
See Also

Shapes with Custom Background Images

backgroundImageWidth

Specifies the shape background image's fractional width.

Type:

Number

This property specifies a fraction from 0 to 1 that represents the shape background image width in relation to the shape width. If the backgroundImageWidth property is set to 1, the image width is equal to the shape width.

The absolute image width is calculated by multiplying the backgroundImageWidth value by the shape width.

baseType

Specifies the base shape type for the custom shape. The built-in shape types are shown in the Shape Types section.

Type: Enums.DiagramShapeType |

String

When the baseType property is specified, the backgroundImageUrl property is not in effect.

category

Specifies a category to which the custom shape belongs.

Type:

String

Use the category property to link a custom shape to a default or custom category. If the property in not specified, it is set to "custom".

To add a category with shapes to the toolbox, add a group with the corresponding category property value to the toolbox object.

connectionPoints[]

An array of the shape's connection points.

Type:

Array<Object>

Diagram connection points

defaultHeight

Specifies the initial height of the shape.

Type:

Number

The units property specifies the measurement unit.

defaultImageUrl

Specifies the URL of an image displayed in a card shape.

Type:

String

A custom shape supports an inner image in two cases:

  • When a shape is created based on a card shape type (the baseType property is set to CardWithImageOnLeft, CardWithImageOnRight, or CardWithImageOnTop). Note that in this case, the image size and position properties are not in effect, because they are predefined in the shape type.
  • When a shape is created based on a custom SVG image (with the backgroundImageUrl property specified). In this case, you can use the following properties to customize inner image size and position: imageHeight, imageWidth, imageLeft, and imageTop.

Use the defaultImageUrl property to specify the image URL.

Diagram - Custom shape's image properties

If the allowEditImage property is set to true, the diagram context menu displays commands that allow users to change the image.

Diagram - Card's context menu

See Also

backgroundImageUrl

defaultText

Specifies the initial text of the shape.

Type:

String

See Also

allowEditText

defaultWidth

Specifies the initial width of the shape.

Type:

Number

The units property specifies the measurement unit.

imageHeight

Specifies the shape image's fractional height.

Type:

Number

The defaultImageUrl option specifies the URL of an image displayed inside the shape. Use the imageHeight option to specify the ratio of the image's height to the shape's height. If the imageHeight property is set to 1, the image height is then equal to the shape height.

The imageHeight option is not in effect if the baseType option is specified.

imageLeft

Specifies the shape image's left offset.

Type:

Number

The defaultImageUrl option specifies the URL of an image displayed inside the shape. Use the imageLeft option to specify the ratio of the image's left offset to the shape's width. If the imageLeft option is set to 0, the image's left edge matches the shape's left edge.

The imageLeft option is not in effect if the baseType option is specified.

imageTop

Specifies the shape image's top offset.

Type:

Number

The defaultImageUrl option specifies the URL of an image displayed inside the shape. Use the imageTop option to specify the ratio of the image's top offset to the shape's height. If the imageTop option is set to 0, the image's top edge matches the shape's top edge.

The imageTop option is not in effect if the baseType option is specified.

imageWidth

Specifies the shape image's fractional width.

Type:

Number

The defaultImageUrl option specifies the URL of an image displayed inside the shape. Use the imageWidth option to specify the ratio of the image's width to the shape's width. If the imageWidth option is set to 1, the image width is equal to the shape width.

The imageWidth option is not in effect if the baseType option is specified.

keepRatioOnAutoSize

Specifies whether the shape maintains its width-to-height ratio on auto resize.

Type:

Boolean

When the Diagram UI component is bound to a data source, shapes are resized to fit the shape's text. Set the keepRatioOnAutoSize property to true to maintain the width-to-height ratio of the shape on auto resize.

maxHeight

Specifies the maximum height of the shape.

Type:

Number

The units property specifies the measurement unit.

maxWidth

Specifies the maximum width of the shape.

Type:

Number

The units property specifies the measurement unit.

minHeight

Specifies the maximum height of the shape.

Type:

Number

The units property specifies the measurement unit.

minWidth

Specifies the minimum width of the shape.

Type:

Number

The units property specifies the measurement unit.

template

Specifies a custom template for the shape.

Type:

template

Template Data:
Name Type Description
item

dxDiagramShape

The shapes object.

IMPORTANT
  • Template content must be presented as SVG elements.

  • We recommend that you do not use the foreignObject element to define template content (Safari does not support this element).

Use the customShapeTemplate property to define a common template for all shapes in the Diagram UI component.

Set a custom shape's allowEditText option to false to disable shape text editing. Otherwise, users can add shape text that may overlap with template content.

If the textExpr option is specified, template content may overlap with text from the data source. Since the textExpr option has the default value 'text', the widget will obtain node texts from the data source’s 'text' field. To prevent this behavior, set the option to an empty string: nodes: { textExpr: "", ....

View Demo

See Also

templateHeight

Specifies the shape template's fractional height.

Type:

Number

This property specifies a fraction from 0 to 1 that represents the shape template height in relation to the shape height. If the templateHeight property is set to 1, the template height is equal to the shape height.

The absolute template height is calculated by multiplying the templateHeight value by the shape height.

templateLeft

Specifies the shape template's left offset.

Type:

Number

This property specifies a fractional left offset of a shape template toward the shape width. If the templateLeft property is set to 0, the template's left edge matches the shape's left edge.

The absolute offset is calculated by multiplying the templateLeft value by the shape's width.

templateTop

Specifies the shape template's top offset.

Type:

Number

This property specifies a fractional top offset of a shape template toward the shape width. If the templateTop property is set to 0, the template's top edge matches the shape's top edge.

The absolute offset is calculated by multiplying the templateTop value by the shape's width.

templateWidth

Specifies the shape template's fractional width.

Type:

Number

This property specifies a fraction from 0 to 1 that represents the shape template width in relation to the shape width. If the templateWidth property is set to 1, the template width is equal to the shape width.

The absolute template width is calculated by multiplying the templateWidth value by the shape width.

textHeight

Specifies the shape text container's height.

Type:

Number

This property specifies a fraction from 0 to 1 that is the height of a shape's text in relation to the shape height. If the textHeight property is set to 1, the text height is equal to the shape height.

The absolute text height is calculated by multiplying the textHeight value by the shape height.

If the textHeight property is set to 0 (zero) or undefined and the autoSizeEnabled property is set to true, the textHeight property value is equal to 1.

textLeft

Specifies the shape text's left offset.

Type:

Number

This property specifies the shape text's left offset (in fractions) in relation to the shape width. If the textLeft property is set to 0, the text's left edge matches the shape's left edge.

The absolute offset is calculated by multiplying the textLeft value by the shape width.

textTop

Specifies the shape text's top offset.

Type:

Number

This property specifies the shape text's top offset (in fractions) in relation to the shape height. If the textTop property is set to 0, the text's top edge matches the shape's top edge.

The absolute offset is calculated by multiplying the textTop value by the shape height.

textWidth

Specifies the shape text container's width.

Type:

Number

This property specifies a fraction from 0 to 1 that is the shape text's width in relation to the shape width. If the textWidth property is set to 1, the text width is equal to the shape width.

The absolute text width is calculated by multiplying the textWidth value by the shape width.

If the textWidth property is set to 0 (zero) or undefined and the autoSizeEnabled property is set to true, the textWidth property value is equal to 1.

title

Specifies the shape's tooltip in the toolbox panel.

Type:

String

toolboxTemplate

Specifies a custom template for the shape in the toolbox.

Type:

template

Template Data:
Name Type Description
item

dxDiagramShape

The shapes object.

IMPORTANT
  • Template content must be presented as SVG elements.

  • We recommend that you do not use the foreignObject element to define template content (Safari does not support this element).

Use the customShapeToolboxTemplate property to define a common template for all diagram shapes in the toolbox.

View Demo

See Also

toolboxWidthToHeightRatio

Specifies the aspect ratio of the shape in the toolbox.

Type:

Number

The size of a shape in the toolbox is determined automatically based on the toolbox width and the number of shapes per row.

Use the toolboxWidthToHeightRatio property to change the aspect ratio of the shape.

type

Specifies the custom shape's identifier.

Type:

String

The type value must be specified and must be unique.

Angular Diagram - customShapes

Provide access to an array of custom shapes.

Selector: dxi-custom-shape
Type:

Array<Object>

Default Value: []

Use the customShapes property to extend a collection of built-in shapes with custom shapes.

Use the toolbox property to add the custom shapes to the toolbox.

app.component.html
app.component.ts
  • <dx-diagram #diagram id="diagram">
  • <dxi-custom-shape
  • category="hardware"
  • type="internet"
  • title="Internet"
  • backgroundImageUrl="images/shapes/internet.svg"
  • [backgroundImageLeft]="0.15"
  • [backgroundImageTop]="0"
  • [backgroundImageWidth]="0.7"
  • [backgroundImageHeight]="0.7"
  • [defaultWidth]="0.75"
  • [defaultHeight]="0.75"
  • defaultText="Internet"
  • [allowEditText]="false"
  • [textLeft]="0"
  • [textTop]="0.7"
  • [textWidth]="1"
  • [textHeight]="0.3">
  • <dxi-connection-point [x]="0.5" [y]="0"></dxi-connection-point>
  • <dxi-connection-point [x]="0.9" [y]="0.5"></dxi-connection-point>
  • <dxi-connection-point [x]="0.5" [y]="1"></dxi-connection-point>
  • <dxi-connection-point [x]="0.1" [y]="0.5"></dxi-connection-point>
  • </dxi-custom-shape>
  • ...
  • <dxo-toolbox>
  • <dxi-group category="hardware" title="Hardware"></dxi-group>
  • </dxo-toolbox>
  • </dx-diagram>
  • import { NgModule, Component, ViewChild, enableProdMode } from '@angular/core';
  • import { BrowserModule } from '@angular/platform-browser';
  • import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
  • import { HttpClient, HttpClientModule } from '@angular/common/http';
  •  
  • import { DxDiagramModule, DxDiagramComponent } from 'devextreme-angular';
  •  
  • @Component({
  • selector: 'app-root',
  • templateUrl: './app.component.html',
  • styleUrls: ['./app.component.css']
  • })
  • export class AppComponent {
  • @ViewChild(DxDiagramComponent, { static: false }, { static: false }) diagram: DxDiagramComponent;
  • // Prior to Angular 8
  • // @ViewChild(DxDiagramComponent, { static: false }) diagram: DxDiagramComponent;
  •  
  • constructor(http: HttpClient) {
  • http.get('data/diagram-hardware.json').subscribe(data => {
  • this.diagram.instance.import(JSON.stringify(data));
  • }, err => {
  • throw 'Data Loading Error'
  • });
  • }
  • }

View Demo

See Also

allowEditImage

Specifies whether a card shape's image can be edited.

Type:

Boolean

Use the defaultImageUrl property to specify the default image that is displayed in the card. Set the allowEditImage property to true to allow users to change the image from a context menu.

Diagram - Card's context menu

See Also

defaultImageUrl

allowEditText

Specifies whether the shape's text can be edited.

Type:

Boolean

See Also

defaultText

allowResize

Specifies whether the shape can be resized.

Type:

Boolean

When shape resizing is enabled you can restrict shape sizes with the following properties: minWidth, maxWidth, minHeight, and maxHeight.

backgroundImageHeight

Specifies the shape background image's fractional height.

Type:

Number

This property specifies a fraction from 0 to 1 that represents the shape background image height in relation to the shape height. If the backgroundImageHeight property is set to 1, the image height is equal to the shape height.

The absolute image height is calculated by multiplying the backgroundImageHeight value by the shape's height.

backgroundImageLeft

Specifies the shape background image's left offset.

Type:

Number

This property specifies a fractional left offset of a shape background image toward the shape width. If the backgroundImageLeft property is set to 0, the image's left edge matches the shape's left edge.

The absolute offset is calculated by multiplying the backgroundImageLeft value by the shape's width.

backgroundImageToolboxUrl

Specifies the shape image displayed in the toolbox.

Type:

String

When a custom shape is created with a custom background image (the backgroundImageUrl property), you can use the backgroundImageToolboxUrl property to specify the image displayed for the shape in the toolbox.

If the property is not set, the toolbox displays an image specified in the backgroundImageUrl property.

NOTE
Shape background images should be supplied as SVG files.

Diagram - Custom shape's image properties

backgroundImageTop

Specifies the shape background image's top offset.

Type:

Number

This property specifies the top offset (in fractions) of a shape's background image in relation to the shape's height. If the backgroundImageTop property is set to 0, the image's top edge matches the shape's top edge.

The absolute offset is calculated by multiplying the backgroundImageTop value by the shape's height.

backgroundImageUrl

Specifies the shape background image's URL.

Type:

String

A custom shape can be created based on a default shape type (the baseType property) or with a custom background image (the backgroundImageUrl property).

Use the backgroundImageToolboxUrl property to specify an image displayed for the shape in the toolbox. If the property is not set, the toolbox displays an image specified in the backgroundImageUrl property.

Diagram - Custom shape's image properties

The backgroundImageUrl property is not in effect if the baseType is specified.

NOTE
Shape background images should be supplied as SVG files.

Rounded Rectangle Shape

  • <!-- roundedRect.svg -->
  • <svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewBox="0 0 48 26">
  • <g>
  • <rect rx="8" ry="8" x="0.5" y="0.5" width="47" height="25"
  • style="fill:#FFFFFF; stroke:#000000; stroke-width:2px;"/>
  • </g>

app.component.html
  • <dx-diagram #diagram id="diagram">
  • <dxi-custom-shape
  • category="custom"
  • type="roundedRect"
  • title="Rounded Rectangle"
  • backgroundImageUrl="images/shapes/roundedRect.svg"
  • [defaultWidth]="0.75"
  • [defaultHeight]="0.5"
  • defaultText="Text"
  • [textTop]="0.35"
  • [textHeight]="0.3">
  • </dxi-custom-shape>
  • <dxo-toolbox>
  • <dxi-group category="custom" title="Custom"></dxi-group>
  • </dxo-toolbox>
  • </dx-diagram>
See Also

Shapes with Custom Background Images

backgroundImageWidth

Specifies the shape background image's fractional width.

Type:

Number

This property specifies a fraction from 0 to 1 that represents the shape background image width in relation to the shape width. If the backgroundImageWidth property is set to 1, the image width is equal to the shape width.

The absolute image width is calculated by multiplying the backgroundImageWidth value by the shape width.

baseType

Specifies the base shape type for the custom shape. The built-in shape types are shown in the Shape Types section.

Type: Enums.DiagramShapeType |

String

When the baseType property is specified, the backgroundImageUrl property is not in effect.

category

Specifies a category to which the custom shape belongs.

Type:

String

Use the category property to link a custom shape to a default or custom category. If the property in not specified, it is set to "custom".

To add a category with shapes to the toolbox, add a group with the corresponding category property value to the toolbox object.

connectionPoints[]

An array of the shape's connection points.

Selector: dxi-connection-point
Type:

Array<Object>

Diagram connection points

defaultHeight

Specifies the initial height of the shape.

Type:

Number

The units property specifies the measurement unit.

defaultImageUrl

Specifies the URL of an image displayed in a card shape.

Type:

String

A custom shape supports an inner image in two cases:

  • When a shape is created based on a card shape type (the baseType property is set to CardWithImageOnLeft, CardWithImageOnRight, or CardWithImageOnTop). Note that in this case, the image size and position properties are not in effect, because they are predefined in the shape type.
  • When a shape is created based on a custom SVG image (with the backgroundImageUrl property specified). In this case, you can use the following properties to customize inner image size and position: imageHeight, imageWidth, imageLeft, and imageTop.

Use the defaultImageUrl property to specify the image URL.

Diagram - Custom shape's image properties

If the allowEditImage property is set to true, the diagram context menu displays commands that allow users to change the image.

Diagram - Card's context menu

See Also

backgroundImageUrl

defaultText

Specifies the initial text of the shape.

Type:

String

See Also

allowEditText

defaultWidth

Specifies the initial width of the shape.

Type:

Number

The units property specifies the measurement unit.

imageHeight

Specifies the shape image's fractional height.

Type:

Number

The defaultImageUrl option specifies the URL of an image displayed inside the shape. Use the imageHeight option to specify the ratio of the image's height to the shape's height. If the imageHeight property is set to 1, the image height is then equal to the shape height.

The imageHeight option is not in effect if the baseType option is specified.

imageLeft

Specifies the shape image's left offset.

Type:

Number

The defaultImageUrl option specifies the URL of an image displayed inside the shape. Use the imageLeft option to specify the ratio of the image's left offset to the shape's width. If the imageLeft option is set to 0, the image's left edge matches the shape's left edge.

The imageLeft option is not in effect if the baseType option is specified.

imageTop

Specifies the shape image's top offset.

Type:

Number

The defaultImageUrl option specifies the URL of an image displayed inside the shape. Use the imageTop option to specify the ratio of the image's top offset to the shape's height. If the imageTop option is set to 0, the image's top edge matches the shape's top edge.

The imageTop option is not in effect if the baseType option is specified.

imageWidth

Specifies the shape image's fractional width.

Type:

Number

The defaultImageUrl option specifies the URL of an image displayed inside the shape. Use the imageWidth option to specify the ratio of the image's width to the shape's width. If the imageWidth option is set to 1, the image width is equal to the shape width.

The imageWidth option is not in effect if the baseType option is specified.

keepRatioOnAutoSize

Specifies whether the shape maintains its width-to-height ratio on auto resize.

Type:

Boolean

When the Diagram UI component is bound to a data source, shapes are resized to fit the shape's text. Set the keepRatioOnAutoSize property to true to maintain the width-to-height ratio of the shape on auto resize.

maxHeight

Specifies the maximum height of the shape.

Type:

Number

The units property specifies the measurement unit.

maxWidth

Specifies the maximum width of the shape.

Type:

Number

The units property specifies the measurement unit.

minHeight

Specifies the maximum height of the shape.

Type:

Number

The units property specifies the measurement unit.

minWidth

Specifies the minimum width of the shape.

Type:

Number

The units property specifies the measurement unit.

template

Specifies a custom template for the shape.

Type:

template

Template Data:
Name Type Description
item

dxDiagramShape

The shapes object.

IMPORTANT
  • Template content must be presented as SVG elements.

  • We recommend that you do not use the foreignObject element to define template content (Safari does not support this element).

Use the customShapeTemplate property to define a common template for all shapes in the Diagram UI component.

Set a custom shape's allowEditText option to false to disable shape text editing. Otherwise, users can add shape text that may overlap with template content.

If the textExpr option is specified, template content may overlap with text from the data source. Since the textExpr option has the default value 'text', the widget will obtain node texts from the data source’s 'text' field. To prevent this behavior, set the option to an empty string: nodes: { textExpr: "", ....

View Demo

See Also

templateHeight

Specifies the shape template's fractional height.

Type:

Number

This property specifies a fraction from 0 to 1 that represents the shape template height in relation to the shape height. If the templateHeight property is set to 1, the template height is equal to the shape height.

The absolute template height is calculated by multiplying the templateHeight value by the shape height.

templateLeft

Specifies the shape template's left offset.

Type:

Number

This property specifies a fractional left offset of a shape template toward the shape width. If the templateLeft property is set to 0, the template's left edge matches the shape's left edge.

The absolute offset is calculated by multiplying the templateLeft value by the shape's width.

templateTop

Specifies the shape template's top offset.

Type:

Number

This property specifies a fractional top offset of a shape template toward the shape width. If the templateTop property is set to 0, the template's top edge matches the shape's top edge.

The absolute offset is calculated by multiplying the templateTop value by the shape's width.

templateWidth

Specifies the shape template's fractional width.

Type:

Number

This property specifies a fraction from 0 to 1 that represents the shape template width in relation to the shape width. If the templateWidth property is set to 1, the template width is equal to the shape width.

The absolute template width is calculated by multiplying the templateWidth value by the shape width.

textHeight

Specifies the shape text container's height.

Type:

Number

This property specifies a fraction from 0 to 1 that is the height of a shape's text in relation to the shape height. If the textHeight property is set to 1, the text height is equal to the shape height.

The absolute text height is calculated by multiplying the textHeight value by the shape height.

If the textHeight property is set to 0 (zero) or undefined and the autoSizeEnabled property is set to true, the textHeight property value is equal to 1.

textLeft

Specifies the shape text's left offset.

Type:

Number

This property specifies the shape text's left offset (in fractions) in relation to the shape width. If the textLeft property is set to 0, the text's left edge matches the shape's left edge.

The absolute offset is calculated by multiplying the textLeft value by the shape width.

textTop

Specifies the shape text's top offset.

Type:

Number

This property specifies the shape text's top offset (in fractions) in relation to the shape height. If the textTop property is set to 0, the text's top edge matches the shape's top edge.

The absolute offset is calculated by multiplying the textTop value by the shape height.

textWidth

Specifies the shape text container's width.

Type:

Number

This property specifies a fraction from 0 to 1 that is the shape text's width in relation to the shape width. If the textWidth property is set to 1, the text width is equal to the shape width.

The absolute text width is calculated by multiplying the textWidth value by the shape width.

If the textWidth property is set to 0 (zero) or undefined and the autoSizeEnabled property is set to true, the textWidth property value is equal to 1.

title

Specifies the shape's tooltip in the toolbox panel.

Type:

String

toolboxTemplate

Specifies a custom template for the shape in the toolbox.

Type:

template

Template Data:
Name Type Description
item

dxDiagramShape

The shapes object.

IMPORTANT
  • Template content must be presented as SVG elements.

  • We recommend that you do not use the foreignObject element to define template content (Safari does not support this element).

Use the customShapeToolboxTemplate property to define a common template for all diagram shapes in the toolbox.

View Demo

See Also

toolboxWidthToHeightRatio

Specifies the aspect ratio of the shape in the toolbox.

Type:

Number

The size of a shape in the toolbox is determined automatically based on the toolbox width and the number of shapes per row.

Use the toolboxWidthToHeightRatio property to change the aspect ratio of the shape.

type

Specifies the custom shape's identifier.

Type:

String

The type value must be specified and must be unique.

Vue Diagram - customShapes

Provide access to an array of custom shapes.

Selector: DxCustomShape
Type:

Array<Object>

Default Value: []

Use the customShapes property to extend a collection of built-in shapes with custom shapes.

Use the toolbox property to add the custom shapes to the toolbox.

App.vue
  • <template>
  • <DxDiagram
  • id="diagram"
  • ref="diagram"
  • >
  • <DxCustomShape
  • :category="'hardware'"
  • :type="'internet'"
  • :title="'Internet'"
  • :background-image-url="'images/shapes/internet.svg'"
  • :background-image-left="0.15"
  • :background-image-top="0"
  • :background-image-width="0.7"
  • :background-image-height="0.7"
  • :default-width="0.75"
  • :default-height="0.75"
  • :default-text="'Internet'"
  • :allow-edit-text="true"
  • :text-left="0"
  • :text-top="0.7"
  • :text-width="1"
  • :text-height="0.3"
  • >
  • <DxConnectionPoint
  • :x="0.5"
  • :y="0"
  • />
  • <DxConnectionPoint
  • :x="0.9"
  • :y="0.5"
  • />
  • <DxConnectionPoint
  • :x="0.5"
  • :y="1"
  • />
  • <DxConnectionPoint
  • :x="0.1"
  • :y="0.5"
  • />
  • </DxCustomShape>
  • ...
  • <DxToolbox :visible="true">
  • <DxGroup
  • :category="'hardware'"
  • :title="'Hardware'"
  • />
  • </DxToolbox>
  • </DxDiagram>
  • </template>
  •  
  • <script>
  • import { DxDiagram, DxGroup, DxToolbox, DxCustomShape, DxConnectionPoint } from 'devextreme-vue/diagram';
  • import 'whatwg-fetch';
  •  
  • export default {
  • components: {
  • DxDiagram, DxGroup, DxToolbox, DxCustomShape, DxConnectionPoint
  • },
  • mounted() {
  • var diagram = this.$refs['diagram'].instance;
  • fetch('data/diagram-hardware.json')
  • .then(function(response) {
  • return response.json();
  • })
  • .then(function(json) {
  • diagram.import(JSON.stringify(json));
  • })
  • .catch(function() {
  • throw 'Data Loading Error';
  • });
  • }
  • };
  • </script>

View Demo

See Also

allowEditImage

Specifies whether a card shape's image can be edited.

Selector: allow-edit-image
Type:

Boolean

Use the defaultImageUrl property to specify the default image that is displayed in the card. Set the allowEditImage property to true to allow users to change the image from a context menu.

Diagram - Card's context menu

See Also

defaultImageUrl

allowEditText

Specifies whether the shape's text can be edited.

Selector: allow-edit-text
Type:

Boolean

See Also

defaultText

allowResize

Specifies whether the shape can be resized.

Selector: allow-resize
Type:

Boolean

When shape resizing is enabled you can restrict shape sizes with the following properties: minWidth, maxWidth, minHeight, and maxHeight.

backgroundImageHeight

Specifies the shape background image's fractional height.

Selector: background-image-height
Type:

Number

This property specifies a fraction from 0 to 1 that represents the shape background image height in relation to the shape height. If the backgroundImageHeight property is set to 1, the image height is equal to the shape height.

The absolute image height is calculated by multiplying the backgroundImageHeight value by the shape's height.

backgroundImageLeft

Specifies the shape background image's left offset.

Selector: background-image-left
Type:

Number

This property specifies a fractional left offset of a shape background image toward the shape width. If the backgroundImageLeft property is set to 0, the image's left edge matches the shape's left edge.

The absolute offset is calculated by multiplying the backgroundImageLeft value by the shape's width.

backgroundImageToolboxUrl

Specifies the shape image displayed in the toolbox.

Selector: background-image-toolbox-url
Type:

String

When a custom shape is created with a custom background image (the backgroundImageUrl property), you can use the backgroundImageToolboxUrl property to specify the image displayed for the shape in the toolbox.

If the property is not set, the toolbox displays an image specified in the backgroundImageUrl property.

NOTE
Shape background images should be supplied as SVG files.

Diagram - Custom shape's image properties

backgroundImageTop

Specifies the shape background image's top offset.

Selector: background-image-top
Type:

Number

This property specifies the top offset (in fractions) of a shape's background image in relation to the shape's height. If the backgroundImageTop property is set to 0, the image's top edge matches the shape's top edge.

The absolute offset is calculated by multiplying the backgroundImageTop value by the shape's height.

backgroundImageUrl

Specifies the shape background image's URL.

Selector: background-image-url
Type:

String

A custom shape can be created based on a default shape type (the baseType property) or with a custom background image (the backgroundImageUrl property).

Use the backgroundImageToolboxUrl property to specify an image displayed for the shape in the toolbox. If the property is not set, the toolbox displays an image specified in the backgroundImageUrl property.

Diagram - Custom shape's image properties

The backgroundImageUrl property is not in effect if the baseType is specified.

NOTE
Shape background images should be supplied as SVG files.

Rounded Rectangle Shape

  • <!-- roundedRect.svg -->
  • <svg xmlns="http://www.w3.org/2000/svg" x="0px" y="0px" viewBox="0 0 48 26">
  • <g>
  • <rect rx="8" ry="8" x="0.5" y="0.5" width="47" height="25"
  • style="fill:#FFFFFF; stroke:#000000; stroke-width:2px;"/>
  • </g>

App.vue
  • <template>
  • <DxDiagram
  • id="diagram"
  • ref="diagram"
  • >
  • <DxCustomShape
  • :category="'custom'"
  • :type="'roundedRect'"
  • :title="'Rounded Rectangle'"
  • :background-image-url="'images/shapes/roundedRect.svg'"
  • :default-width="0.75"
  • :default-height="0.5"
  • :default-text="'Text'"
  • :text-top="0.35"
  • :text-height="0.3"
  • >
  • </DxCustomShape>
  • <DxToolbox :visible="true">
  • <DxGroup
  • :category="'custom'"
  • :title="'Custom'"
  • />
  • </DxToolbox>
  • </DxDiagram>
  • </template>
See Also

Shapes with Custom Background Images

backgroundImageWidth

Specifies the shape background image's fractional width.

Selector: background-image-width
Type:

Number

This property specifies a fraction from 0 to 1 that represents the shape background image width in relation to the shape width. If the backgroundImageWidth property is set to 1, the image width is equal to the shape width.

The absolute image width is calculated by multiplying the backgroundImageWidth value by the shape width.

baseType

Specifies the base shape type for the custom shape. The built-in shape types are shown in the Shape Types section.

Selector: base-type
Type: Enums.DiagramShapeType |

String

When the baseType property is specified, the backgroundImageUrl property is not in effect.

category

Specifies a category to which the custom shape belongs.

Type:

String

Use the category property to link a custom shape to a default or custom category. If the property in not specified, it is set to "custom".

To add a category with shapes to the toolbox, add a group with the corresponding category property value to the toolbox object.

connectionPoints[]

An array of the shape's connection points.

Selector: DxConnectionPoint
Type:

Array<Object>

Diagram connection points

defaultHeight

Specifies the initial height of the shape.

Selector: default-height
Type:

Number

The units property specifies the measurement unit.

defaultImageUrl

Specifies the URL of an image displayed in a card shape.

Selector: default-image-url
Type:

String

A custom shape supports an inner image in two cases:

  • When a shape is created based on a card shape type (the baseType property is set to CardWithImageOnLeft, CardWithImageOnRight, or CardWithImageOnTop). Note that in this case, the image size and position properties are not in effect, because they are predefined in the shape type.
  • When a shape is created based on a custom SVG image (with the backgroundImageUrl property specified). In this case, you can use the following properties to customize inner image size and position: imageHeight, imageWidth, imageLeft, and imageTop.

Use the defaultImageUrl property to specify the image URL.

Diagram - Custom shape's image properties

If the allowEditImage property is set to true, the diagram context menu displays commands that allow users to change the image.

Diagram - Card's context menu

See Also

backgroundImageUrl

defaultText

Specifies the initial text of the shape.

Selector: default-text
Type:

String

See Also

allowEditText

defaultWidth

Specifies the initial width of the shape.

Selector: default-width
Type:

Number

The units property specifies the measurement unit.

imageHeight

Specifies the shape image's fractional height.

Selector: image-height
Type:

Number

The defaultImageUrl option specifies the URL of an image displayed inside the shape. Use the imageHeight option to specify the ratio of the image's height to the shape's height. If the imageHeight property is set to 1, the image height is then equal to the shape height.

The imageHeight option is not in effect if the baseType option is specified.

imageLeft

Specifies the shape image's left offset.

Selector: image-left
Type:

Number

The defaultImageUrl option specifies the URL of an image displayed inside the shape. Use the imageLeft option to specify the ratio of the image's left offset to the shape's width. If the imageLeft option is set to 0, the image's left edge matches the shape's left edge.

The imageLeft option is not in effect if the baseType option is specified.

imageTop

Specifies the shape image's top offset.

Selector: image-top
Type:

Number

The defaultImageUrl option specifies the URL of an image displayed inside the shape. Use the imageTop option to specify the ratio of the image's top offset to the shape's height. If the imageTop option is set to 0, the image's top edge matches the shape's top edge.

The imageTop option is not in effect if the baseType option is specified.

imageWidth

Specifies the shape image's fractional width.

Selector: image-width
Type:

Number

The defaultImageUrl option specifies the URL of an image displayed inside the shape. Use the imageWidth option to specify the ratio of the image's width to the shape's width. If the imageWidth option is set to 1, the image width is equal to the shape width.

The imageWidth option is not in effect if the baseType option is specified.

keepRatioOnAutoSize

Specifies whether the shape maintains its width-to-height ratio on auto resize.

Selector: keep-ratio-on-auto-size
Type:

Boolean

When the Diagram UI component is bound to a data source, shapes are resized to fit the shape's text. Set the keepRatioOnAutoSize property to true to maintain the width-to-height ratio of the shape on auto resize.

maxHeight

Specifies the maximum height of the shape.

Selector: max-height
Type:

Number

The units property specifies the measurement unit.

maxWidth

Specifies the maximum width of the shape.

Selector: max-width
Type:

Number

The units property specifies the measurement unit.

minHeight

Specifies the maximum height of the shape.

Selector: min-height
Type:

Number

The units property specifies the measurement unit.

minWidth

Specifies the minimum width of the shape.

Selector: min-width
Type:

Number

The units property specifies the measurement unit.

template

Specifies a custom template for the shape.

Type:

template

Template Data:
Name Type Description
item

dxDiagramShape

The shapes object.

IMPORTANT
  • Template content must be presented as SVG elements.

  • We recommend that you do not use the foreignObject element to define template content (Safari does not support this element).

Use the customShapeTemplate property to define a common template for all shapes in the Diagram UI component.

Set a custom shape's allowEditText option to false to disable shape text editing. Otherwise, users can add shape text that may overlap with template content.

If the textExpr option is specified, template content may overlap with text from the data source. Since the textExpr option has the default value 'text', the widget will obtain node texts from the data source’s 'text' field. To prevent this behavior, set the option to an empty string: nodes: { textExpr: "", ....

View Demo

See Also

templateHeight

Specifies the shape template's fractional height.

Selector: template-height
Type:

Number

This property specifies a fraction from 0 to 1 that represents the shape template height in relation to the shape height. If the templateHeight property is set to 1, the template height is equal to the shape height.

The absolute template height is calculated by multiplying the templateHeight value by the shape height.

templateLeft

Specifies the shape template's left offset.

Selector: template-left
Type:

Number

This property specifies a fractional left offset of a shape template toward the shape width. If the templateLeft property is set to 0, the template's left edge matches the shape's left edge.

The absolute offset is calculated by multiplying the templateLeft value by the shape's width.

templateTop

Specifies the shape template's top offset.

Selector: template-top
Type:

Number

This property specifies a fractional top offset of a shape template toward the shape width. If the templateTop property is set to 0, the template's top edge matches the shape's top edge.

The absolute offset is calculated by multiplying the templateTop value by the shape's width.

templateWidth

Specifies the shape template's fractional width.

Selector: template-width
Type:

Number

This property specifies a fraction from 0 to 1 that represents the shape template width in relation to the shape width. If the templateWidth property is set to 1, the template width is equal to the shape width.

The absolute template width is calculated by multiplying the templateWidth value by the shape width.

textHeight

Specifies the shape text container's height.

Selector: text-height
Type:

Number

This property specifies a fraction from 0 to 1 that is the height of a shape's text in relation to the shape height. If the textHeight property is set to 1, the text height is equal to the shape height.

The absolute text height is calculated by multiplying the textHeight value by the shape height.

If the textHeight property is set to 0 (zero) or undefined and the autoSizeEnabled property is set to true, the textHeight property value is equal to 1.

textLeft

Specifies the shape text's left offset.

Selector: text-left
Type:

Number

This property specifies the shape text's left offset (in fractions) in relation to the shape width. If the textLeft property is set to 0, the text's left edge matches the shape's left edge.

The absolute offset is calculated by multiplying the textLeft value by the shape width.

textTop

Specifies the shape text's top offset.

Selector: text-top
Type:

Number

This property specifies the shape text's top offset (in fractions) in relation to the shape height. If the textTop property is set to 0, the text's top edge matches the shape's top edge.

The absolute offset is calculated by multiplying the textTop value by the shape height.

textWidth

Specifies the shape text container's width.

Selector: text-width
Type:

Number

This property specifies a fraction from 0 to 1 that is the shape text's width in relation to the shape width. If the textWidth property is set to 1, the text width is equal to the shape width.

The absolute text width is calculated by multiplying the textWidth value by the shape width.

If the textWidth property is set to 0 (zero) or undefined and the autoSizeEnabled property is set to true, the textWidth property value is equal to 1.

title

Specifies the shape's tooltip in the toolbox panel.

Type:

String

toolboxTemplate

Specifies a custom template for the shape in the toolbox.

Selector: toolbox-template
Type:

template

Template Data:
Name Type Description
item

dxDiagramShape

The shapes object.

IMPORTANT
  • Template content must be presented as SVG elements.

  • We recommend that you do not use the foreignObject element to define template content (Safari does not support this element).

Use the customShapeToolboxTemplate property to define a common template for all diagram shapes in the toolbox.

View Demo

See Also

toolboxWidthToHeightRatio

Specifies the aspect ratio of the shape in the toolbox.

Selector: toolbox-width-to-height-ratio
Type:

Number

The size of a shape in the toolbox is determined automatically based on the toolbox width and the number of shapes per row.

Use the toolboxWidthToHeightRatio property to change the aspect ratio of the shape.

type

Specifies the custom shape's identifier.

Type:

String

The type value must be specified and must be unique.